// CMSC317 assignment 2
// different binary thresholding functions
//
// (1) complete the two missing functions: 
//      - calcmean 
//      - calcotsu 
//
// (2) For the report (PDF):
//      - show results (binary images) for the different thresholds
//      - find an image where otsu fails; reflect on why it failed? 
//      - describe another way to pick the threshold 
//
// submit your sketch as a .zip file with the PDF and images included
//
// Keith O'Hara <kohara@bard.edu>
// Feb 2019

import processing.video.*;

Capture cam;
//PImage cam;

int hist[];
float thresh = 128;

void setup() {
  size(640, 480);
  
  // for the webcam
  cam = new Capture(this, width/2, height/2);
  cam.start();
  
  // to load image from file
  //cam = loadImage("img-01861.png");
  //cam.filter(GRAY);  // to convert image to gray scale
  //cam.resize(width/2, height/2);
  
  hist = new int[256];
}

void mousePressed() {
  println("thresh = " + thresh);
}

void drawhist(int [] h) {
  int sum = 0;
  noStroke();    
  for (int i = 0; i < h.length; i++) {
    //draw pdf
    fill(i);
    rect(i, height/2, 1, h[i]/10);

    //draw cdf
    sum += h[i];
    rect(width/2+i, height/2, 1, sum/300);
  }
}

void calchist(PImage img, int []h) {
  img.loadPixels();
  //clear the histogram
  for (int i = 0; i < h.length; i++) {
    h[i] = 0;
  }
  for (int i = 0; i < img.pixels.length; i++) {
    // to gamma correct or not?
    int value = (img.pixels[i] & 0xFF00) >> 8;
    h[value]++;
  }
}

// given a histogram, find the mean
int calcmean(int[] h) {
  return 0;
}

// given a histogram, find the otsu threshold
int calcotsu(int[] h) {
  return 0;  
}

// given a histogram, find the median
int calcmedian(int []h) {
  int tsum = 0;
  for (int i = 0; i < h.length; i++) {
    tsum += h[i];
  }
  int sum = 0;
  for (int i = 0; i < h.length; i++) {
    sum += h[i];
    if (sum >= tsum/2) return i;
  }
  return -1;
}


void draw() {
    PImage frame = cam.get(); // make a copy of the image
    frame.filter(GRAY);
   
    background(0, 0, 48);

    image(frame, 0, 0);
    thresh = mouseX % (width/2);
    frame.loadPixels();

    calchist(frame, hist);
    drawhist(hist);

    // calcuate median and draw it on the histogram
    stroke(0, 255, 0);
    int m = calcmedian(hist);
    line(m, height/2, m, height);
    line(m+width/2, height/2, m+width/2, height);

    // calcuate mean and draw it on the histogram
    stroke(0, 255, 255);
    int u = calcmean(hist);
    line(u, height/2, u, height);
    line(u+width/2, height/2, u+width/2, height);

    // calcuate otsu threshold and draw it on the histogram
    stroke(255, 255, 0);
    int o = calcotsu(hist);
    line(o, height/2, o, height);
    line(o+width/2, height/2, o+width/2, height);
    
    if (key == 'u') thresh = u;
    if (key == 'm') thresh = m;
    if (key == 'o') thresh = o;

    for (int i = 0; i < frame.pixels.length; i++) {
      // to gamma correct or not?
      int ivalue = frame.pixels[i] & 0xFF00 >> 8;
      //float value = pow(ivalue/255.0, 1/2.2)*255;
      int value = ivalue;
      frame.pixels[i] = value > thresh? 0xFFFFFF: 0x000000;
    }
    frame.updatePixels();
    //frame.filter(DILATE);
    //frame.filter(DILATE);
    //frame.filter(DILATE);
    image(frame, width/2, 0);

    stroke(0, 0, 255);
    fill(0, 0, 255);
    rect(thresh-3, height-100, 6, 45);
    rect(thresh+width/2-3, height-100, 6, 45);

}

void captureEvent(Capture c) {
  c.read();
}
